using UnityEngine;
using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;


//BASE SCRIPT
namespace Mod
{
    
    public class Mod
    {
        static string AGtag = " <color=white>[AG] <color=white>";  
         
        public static void Main()
        {
            

            CategoryBuilder.Create("Apocalypse Gear Pack Mod", "Apocalypse Gear Pack Mod", ModAPI.LoadSprite("logo_category.png"));



                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 1",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/survivor_01.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("cap 01");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Survivors/survivor_cap.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 2",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor02thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor02.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("cap 02");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Survivors/cap02.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                            GameObject detail2 = new GameObject("cape");
                            detail2.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody")); //Lower Body
                            detail2.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail2.transform.localEulerAngles = Vector3.zero;
                            detail2.transform.localScale = Vector2.one;

                            SpriteRenderer detail2SpriteRenderer = detail2.AddComponent<SpriteRenderer>();
                            detail2SpriteRenderer.sprite = ModAPI.LoadSprite("art/Survivors/cape02.png"); //path to clothes on the belt
                            detail2SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 3",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor03thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor03.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 4",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor04thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor04.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 5",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor05thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor05.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);                        
                            GameObject detail2 = new GameObject("cape");
                            detail2.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody")); //Lower Body
                            detail2.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail2.transform.localEulerAngles = Vector3.zero;
                            detail2.transform.localScale = Vector2.one;

                            SpriteRenderer detail2SpriteRenderer = detail2.AddComponent<SpriteRenderer>();
                            detail2SpriteRenderer.sprite = ModAPI.LoadSprite("art/Survivors/cape05.png"); //path to clothes on the belt
                            detail2SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 6",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor06thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor06.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("cap 02");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Survivors/cap06.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 7",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor07thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor07.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("cap 07");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Survivors/cap07.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 8",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor08thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor08.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("cap 08");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Survivors/cap08.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 9",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor09thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor09.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail2 = new GameObject("boob");
                            detail2.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody")); //Lower Body
                            detail2.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail2.transform.localEulerAngles = Vector3.zero;
                            detail2.transform.localScale = Vector2.one;

                            SpriteRenderer detail2SpriteRenderer = detail2.AddComponent<SpriteRenderer>();
                            detail2SpriteRenderer.sprite = ModAPI.LoadSprite("art/Survivors/boob09.png"); //path to clothes on the belt
                            detail2SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 10",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor10thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor10.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 11",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor11thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor11.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 12",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor12thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor12.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = AGtag + "Survivor 13",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Survivors/Survivor13thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Survivors/Survivor13.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        
                        }
                    }
                );

                

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Axe"),
                        NameOverride = AGtag + "Apocalypse Axe",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/axe_1thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var axeHandle = Instance.transform.GetChild(0);
                            axeHandle.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/axe_1.png");
                            var axeHead = axeHandle.GetChild(0);
                            axeHead.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/axe_2.png");
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Axe"),
                    NameOverride = "Battle Axe",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("art/Melee/battlethumb.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        var axeHandle = Instance.transform.GetChild(0);
                        axeHandle.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/battle_axe.png");
                        var axeHead = axeHandle.GetChild(0);
                        axeHead.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/battle_axe_1.png");
                        var properties = ModAPI.FindPhysicalProperties("Metal");
                        properties.Sharp = true;
                        properties.SharpAxes = new SharpAxis[]
                        {
                            new SharpAxis(Vector2.right, 0f, 0.5f, true, false)
                        };
                        axeHead.gameObject.GetComponent<PhysicalBehaviour>().Properties = properties;
                    }
                }
            );
                
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Crowbar",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/CrowbarThumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/Crowbar.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Hammer",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/hammerThumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/hammer.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Rusty Crowbar",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/RustyCrowbarthumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/RustyCrowbar.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );


                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Pipe",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/PipeThumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/Pipe.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Knife"),
                        NameOverride = AGtag + "Hunter Knife",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/hunter_knifethumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/hunter_knife.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Knife"),
                        NameOverride = AGtag + "Homemade Knife",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/knife_1thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/knife_1.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Knife"),
                        NameOverride = AGtag + "Combat Knife",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/knife_3thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/knife_3.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

             ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Knife"),
                        NameOverride = AGtag + "Rusty Knife",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/knife_2thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/knife_2.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

            
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Shovel",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/shovelthumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/shovel.png");
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Knife"),
                        NameOverride = AGtag + "Broken Bottle",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/bottle_breakthumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/bottle_break.png");
                            Instance.FixColliders();
                        }
                    }
                );
                

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Golf club",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/golfclubThumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/golfclub.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Medkit",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Items/MedkitThumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Items/Medkit.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );


                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Guitar",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Items/GuitarThumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Items/Guitar.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Rusty Golf club",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/rustygolfclubthumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/rustygolfclub.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Swat Shield",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Melee/swat_shieldthumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Melee/swat_shield.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Grenade"),
                        NameOverride = AGtag + "Grenade",
                        NameToOrderByOverride = "A",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Guns/grenadethumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Guns/grenade.png");
                            Instance.FixColliders();
                        }
                    }
                );


                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
                        NameOverride = AGtag + "AKS-74U", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "", //new item description
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Guns/AKS-74Uthumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Guns/AKS-74U.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Shotgun"), //item to derive from
                        NameOverride = AGtag + "Mossberg 590", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "", //new item description
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Guns/Mossberg590thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Guns/Mossberg590.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Shotgun"), //item to derive from
                        NameOverride = AGtag + "Pump shotgun", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "", //new item description
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Guns/pumpshotgunthumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Guns/pumpshotgun.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Magnum Revolver"), //item to derive from
                        NameOverride = AGtag + "Magnum", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "", //new item description
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Guns/magnumthumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Guns/magnum.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"), //item to derive from
                        NameOverride = AGtag + "Sniper Rifle", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "", //new item description
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Guns/Sniperthumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Guns/Sniper.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Assault Rifle"), //item to derive from
                        NameOverride = AGtag + "Assault Rifle", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "", //new item description
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Guns/AssaultRiflethumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Guns/AssaultRifle.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), //item to derive from
                        NameOverride = AGtag + "Mini uzi", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "", //new item description
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Guns/miniuzithumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Guns/miniuzi.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Revolver"), //item to derive from
                        NameOverride = AGtag + "Short Revolver", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "in my opinion it's not short, it's downright sufficient, and I bet it has a great personality", //new item description
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Guns/short_revolverthumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Guns/short_revolver.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Assault Rifle"), //item to derive from
                        NameOverride = AGtag + "M16", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "", //new item description
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Guns/M16thumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Guns/M16.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Balaclava",
                        DescriptionOverride = "Perfect for robbing a store",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Arrmors/balaclavathumb.png"),
                        AfterSpawn = (Instance) =>
                        { 
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Arrmors/balaclava.png");
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                            armor.stabResistance = 000048f;
                            armor.armorPiece = "Head";
                            armor.armorTier = 0;
                            armor.otherSprite = ("art/Arrmors/balaclava.png");
                            Instance.FixColliders();
                        }  
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Metal mask",
                        DescriptionOverride = "Maybe it protects you from zombies",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Arrmors/metal_maskthumb.png"),
                        AfterSpawn = (Instance) =>
                        { 
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Arrmors/metal_mask.png");
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                            armor.stabResistance = 004448f;
                            armor.armorPiece = "Head";
                            armor.armorTier = 0;
                            armor.otherSprite = ("art/Arrmors/metal_mask.png");
                            Instance.FixColliders();
                        }  
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Gas Mask",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Arrmors/GasMask_1thumb.png"),
                        AfterSpawn = (Instance) =>
                        { 
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Arrmors/GasMask_1.png");
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                            armor.stabResistance = 000448f;
                            armor.armorPiece = "Head";
                            armor.armorTier = 0;
                            armor.otherSprite = ("art/Arrmors/GasMask_1.png");
                            Instance.FixColliders();
                        }  
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Hat 1",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Arrmors/hat_1thumb.png"),
                        AfterSpawn = (Instance) =>
                        { 
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Arrmors/hat_1.png");
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                            armor.stabResistance = 000448f;
                            armor.armorPiece = "Head";
                            armor.armorTier = 0;
                            armor.otherSprite = ("art/Arrmors/hat_1.png");
                            Instance.FixColliders();
                        }  
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Backpack 1",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Arrmors/back_1thumb.png"),
                        AfterSpawn = (Instance) =>
                        { 
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Arrmors/back_1.png");
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                            armor.stabResistance = 000448f;
                            armor.armorPiece = "UpperBody";
                            armor.armorTier = 0;
                            armor.otherSprite = ("art/Arrmors/back_1.png");
                            Instance.FixColliders();
                        }  
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Backpack 2",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Arrmors/back_2thumb.png"),
                        AfterSpawn = (Instance) =>
                        { 
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Arrmors/back_2.png");
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                            armor.stabResistance = 000448f;
                            armor.armorPiece = "UpperBody";
                            armor.armorTier = 0;
                            armor.otherSprite = ("art/Arrmors/back_2.png");
                            Instance.FixColliders();
                        }  
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Backpack 3",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Arrmors/back_3thumb.png"),
                        AfterSpawn = (Instance) =>
                        { 
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Arrmors/back_3.png");
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                            armor.stabResistance = 000448f;
                            armor.armorPiece = "UpperBody";
                            armor.armorTier = 0;
                            armor.otherSprite = ("art/Arrmors/back_3.png");
                            Instance.FixColliders();
                        }  
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = AGtag + "Backpack 4",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Apocalypse Gear Pack Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Arrmors/back_4thumb.png"),
                        AfterSpawn = (Instance) =>
                        { 
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Arrmors/back_4.png");
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                            armor.stabResistance = 000448f;
                            armor.armorPiece = "UpperBody";
                            armor.armorTier = 0;
                            armor.otherSprite = ("art/Arrmors/back_4.png");
                            Instance.FixColliders();
                        }  
                    }
                );



            
                
  
        }
    }
}

public class RandomHumanTextureBehaviour : MonoBehaviour //credit to mishanya for this behaviour
	{
		public List<Texture2D> Textures = new List<Texture2D>();
		int chosenIndex = 0;
		public PersonBehaviour person;
		ContextMenuButton menuButton;
		public void Start()
		{
			chosenIndex = UnityEngine.Random.Range(0, Textures.Count - -1); 
			ChangeTexture();   
			GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(menuButton = new ContextMenuButton("ChangeTexture", "Change Texture", "Switches to the change human skin", new UnityAction[1]
				 {
				(UnityAction) (() =>
				{
					ChangeTexture();
					foreach (var humanSkin in person.Limbs)
					{
						if (humanSkin.GetComponent<RandomHumanTextureBehaviour>())
						{
						   humanSkin.GetComponent<RandomHumanTextureBehaviour>().chosenIndex = chosenIndex;
						}
					}

				})
				 }));     
		}
		public void ChangeTexture()
		{
			chosenIndex -= 1;
			if (chosenIndex > Textures.Count - 1)
				chosenIndex = 0;
			person.SetBodyTextures(Textures[chosenIndex]);
		}
	}
            